function [mj, mi , mlen , maxC] = JOCOR(x,y,minLength,k)

n = length(x);
m = length(y);

if n < m
   ttt = x;
   x = y;
   y = ttt;
   
n = length(x);
m = length(y);

end



x = zNorm(x);
y = zNorm(y);

maxV = max([y x]);

if sum(isnan(x)) > 0 || sum(isnan(y)) > 0
    'NaN inside'
    mi = 0; mj = 0; mlen = 0; maxC = 0;
   return; 
end


mi = -1;
mj = -1;
mlen = 0;
maxC = -1;

for i = 1:m
    z(i,:) = multiply(x(1:n),y(i:m));
end


    %compute y stats -- O(n)
    cum_sumy = cumsum([0 y]);
    cum_sumy2 =  cumsum([0 y].^2);

    
    %compute x stats -- O(n)
    cum_sumx = cumsum([0 x]);
    cum_sumx2 =  cumsum([0 x].^2);

for i = 1:m-minLength+1
    for j = 1:k:n-minLength+1
        maxL = min([m-i+1 n-j+1]);

        len = minLength;
   
        while len < maxL

            sumxy = z(i,m-i+j) - z(i+len,m-i+j);
            
            sumx2 = cum_sumx2(len+j)-cum_sumx2(j);
            sumx = cum_sumx(len+j)-cum_sumx(j);
            meanx = sumx/len;
            sigmax2 = (sumx2/len)-(meanx^2);
            sigmax = sqrt(sigmax2);
            
            
            sumy2 = cum_sumy2(len+i)-cum_sumy2(i);
            sumy = cum_sumy(len+i)-cum_sumy(i);
            meany = sumy/len;
            sigmay2 = (sumy2/len)-(meany^2);
            sigmay = sqrt(sigmay2);
            
            if( sigmax == 0 || sigmay == 0 || imag(sigmax) > 0 || imag(sigmay) > 0 )
                len = len+1;
                continue;
            end
            
            c = ( sumxy - len*meanx*meany ) / ( len*sigmax*sigmay );
            
            if( c > maxC )
            
                mi = i;
                mj = j;
                mlen = len;
                maxC = c;
            end
            
            dist = (1-c);
			bestD = (1-maxC);
			
			zz = maxV;
			factor = 1.0 / ( (len-1)/len + (len-1)*(zz*zz)/(len*len)  );
			
			
			a = floor(log(bestD/dist)/(log(factor)-1.0/len));
			
			
			 if ( a > 0 && imag(a) == 0)
				ttt = a;
             else
				ttt = 0;
             end

			len = len + ttt + 1;
			
            
        end
    end
end
  figure;
  plotJoin(x,y,mi,mj,mlen,maxC);

