function z = multiply(x,y)
    %x is the data, y is the query

    n = length(x);
    m = length(y);
    x(n+1:2*n) = 0;
    y = y(end:-1:1);                                %Reverse the query
    y(m+1:2*n) = 0;
    
    %The main trick of getting dot products in O(n log n) time
    X = fft(x);
    Y = fft(y);
    Z = X.*Y;
    z = ifft(Z);
